{
    "$graph": [
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/alignment_index"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "id": "#main/bin_size_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/blacklist_bed"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/encode_blacklist"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/gene_annotation"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/gene_track"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/genome_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/preferred_barcodes"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/promoters"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/reference_genome_fasta"
                },
                {
                    "type": "Directory",
                    "id": "#main/sequence_directory"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/size_index"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/tmp_folder"
                }
            ],
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "steps": [
                {
                    "scatter": [
                        "#main/create_and_analyze_snap_file/input_fastq1",
                        "#main/create_and_analyze_snap_file/input_fastq2",
                        "#main/create_and_analyze_snap_file/input_barcode_fastq"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": "#snaptools_create_snap_file.cwl",
                    "in": [
                        {
                            "source": "#main/alignment_index",
                            "id": "#main/create_and_analyze_snap_file/alignment_index"
                        },
                        {
                            "source": "#main/bin_size_list",
                            "id": "#main/create_and_analyze_snap_file/bin_size_list"
                        },
                        {
                            "source": "#main/blacklist_bed",
                            "id": "#main/create_and_analyze_snap_file/blacklist_bed"
                        },
                        {
                            "source": "#main/encode_blacklist",
                            "id": "#main/create_and_analyze_snap_file/encode_blacklist"
                        },
                        {
                            "source": "#main/gene_annotation",
                            "id": "#main/create_and_analyze_snap_file/gene_annotation"
                        },
                        {
                            "source": "#main/gene_track",
                            "id": "#main/create_and_analyze_snap_file/gene_track"
                        },
                        {
                            "source": "#main/genome_name",
                            "id": "#main/create_and_analyze_snap_file/genome_name"
                        },
                        {
                            "source": "#main/gather_sequence_bundles/barcode_fastq_files",
                            "id": "#main/create_and_analyze_snap_file/input_barcode_fastq"
                        },
                        {
                            "source": "#main/gather_sequence_bundles/fastq1_files",
                            "id": "#main/create_and_analyze_snap_file/input_fastq1"
                        },
                        {
                            "source": "#main/gather_sequence_bundles/fastq2_files",
                            "id": "#main/create_and_analyze_snap_file/input_fastq2"
                        },
                        {
                            "source": "#main/preferred_barcodes",
                            "id": "#main/create_and_analyze_snap_file/preferred_barcodes"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/create_and_analyze_snap_file/processes"
                        },
                        {
                            "source": "#main/promoters",
                            "id": "#main/create_and_analyze_snap_file/promoters"
                        },
                        {
                            "source": "#main/reference_genome_fasta",
                            "id": "#main/create_and_analyze_snap_file/reference_genome_fasta"
                        },
                        {
                            "source": "#main/size_index",
                            "id": "#main/create_and_analyze_snap_file/size_index"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/create_and_analyze_snap_file/threads"
                        },
                        {
                            "source": "#main/tmp_folder",
                            "id": "#main/create_and_analyze_snap_file/tmp_folder"
                        }
                    ],
                    "out": [
                        "#main/create_and_analyze_snap_file/zipped_files",
                        "#main/create_and_analyze_snap_file/report_files",
                        "#main/create_and_analyze_snap_file/bam_file",
                        "#main/create_and_analyze_snap_file/alignment_qc_report",
                        "#main/create_and_analyze_snap_file/fragment_file",
                        "#main/create_and_analyze_snap_file/snap_file",
                        "#main/create_and_analyze_snap_file/snap_qc_file",
                        "#main/create_and_analyze_snap_file/analysis_CSV_files",
                        "#main/create_and_analyze_snap_file/analysis_BED_files",
                        "#main/create_and_analyze_snap_file/analysis_PDF_files",
                        "#main/create_and_analyze_snap_file/analysis_HDF5_files",
                        "#main/create_and_analyze_snap_file/analysis_RDS_objects",
                        "#main/create_and_analyze_snap_file/analysis_TXT_files",
                        "#main/create_and_analyze_snap_file/analysis_MTX_files",
                        "#main/create_and_analyze_snap_file/motif_CSV_files",
                        "#main/create_and_analyze_snap_file/motif_RData_file"
                    ],
                    "id": "#main/create_and_analyze_snap_file"
                },
                {
                    "run": "#gather_sequence_bundles.cwl",
                    "in": [
                        {
                            "source": "#main/sequence_directory",
                            "id": "#main/gather_sequence_bundles/sequence_directory"
                        }
                    ],
                    "out": [
                        "#main/gather_sequence_bundles/fastq1_files",
                        "#main/gather_sequence_bundles/fastq2_files",
                        "#main/gather_sequence_bundles/barcode_fastq_files"
                    ],
                    "id": "#main/gather_sequence_bundles"
                }
            ],
            "id": "#main",
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapATAC/tree/feature/snap-analysis",
            "https://schema.org/dateCreated": "2020-02-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/alignment_qc_report",
                    "id": "#main/alignment_qc_report"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/analysis_BED_files",
                    "id": "#main/analysis_BED_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/analysis_CSV_files",
                    "id": "#main/analysis_CSV_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/analysis_HDF5_files",
                    "id": "#main/analysis_HDF5_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/analysis_MTX_files",
                    "id": "#main/analysis_MTX_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/analysis_PDF_files",
                    "id": "#main/analysis_PDF_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/analysis_RDS_objects",
                    "id": "#main/analysis_RDS_objects"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/analysis_TXT_files",
                    "id": "#main/analysis_TXT_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/bam_file",
                    "id": "#main/bam_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/fragment_file",
                    "id": "#main/fragment_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/motif_CSV_files",
                    "id": "#main/motif_CSV_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/motif_RData_file",
                    "id": "#main/motif_RData_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/report_files",
                    "id": "#main/report_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/snap_file",
                    "id": "#main/snap_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/snap_qc_file",
                    "id": "#main/snap_qc_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#main/create_and_analyze_snap_file/zipped_files",
                    "id": "#main/zipped_files"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gather_sequence_bundles.cwl",
            "label": "gather sequence bundles",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        "$(inputs.sequence_directory)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "The directory with sample fastq or fastq.gz files.",
                    "id": "#gather_sequence_bundles.cwl/gather_sequence_bundles/sequence_directory"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "input.json",
                        "loadContents": true,
                        "outputEval": "${\n    var bundle_array_str = self[0].contents;\n    var bundle_array = JSON.parse(bundle_array_str);\n    var file_array = [];\n    for (var i =0; i < bundle_array.length; i++) {i\n        // The dictionary key 'input_barcode_fastq' must match the key used\n        // in the string template SEQUENCES_TEMPLATE in gather_sequence_files.py\n        var file = bundle_array[i].input_barcode_fastq;\n        file_array.push(file);\n    }\n    return file_array;\n }\n"
                    },
                    "id": "#gather_sequence_bundles.cwl/gather_sequence_bundles/barcode_fastq_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "input.json",
                        "loadContents": true,
                        "outputEval": "${\n    var bundle_array_str = self[0].contents;\n    var bundle_array = JSON.parse(bundle_array_str);\n    var file_array = [];\n    for (var i =0; i < bundle_array.length; i++) {\n        // The dictionary key 'input_fastq1' must match the key used\n        // in the string template SEQUENCES_TEMPLATE in gather_sequence_files.py\n        var file = bundle_array[i].input_fastq1;\n        file_array.push(file);\n    }\n    return file_array;\n }\n"
                    },
                    "id": "#gather_sequence_bundles.cwl/gather_sequence_bundles/fastq1_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "input.json",
                        "loadContents": true,
                        "outputEval": "${\n    var bundle_array_str = self[0].contents;\n    var bundle_array = JSON.parse(bundle_array_str);\n    var file_array = [];\n    for (var i =0; i < bundle_array.length; i++) {\n        // The dictionary key 'input_fastq2' must match the key used\n        // in the string template SEQUENCES_TEMPLATE in gather_sequence_files.py\n        var file = bundle_array[i].input_fastq2;\n        file_array.push(file);\n    }\n    return file_array;\n }\n"
                    },
                    "id": "#gather_sequence_bundles.cwl/gather_sequence_bundles/fastq2_files"
                }
            ],
            "baseCommand": [
                "/opt/gather_sequence_files.py"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2020-03-20",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Pearl",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snapanalysis_add_pmat_tool.cwl",
            "label": "snapanalysis add pmat",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        {
                            "entry": "$(inputs.snap_file)",
                            "writable": true
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--buffer-size"
                    },
                    "doc": "Max number of barcodes be stored in memory (default 1000).",
                    "id": "#snapanalysis_add_pmat_tool.cwl/snapanalysis_add_pmat_tool/buffer_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--peak-file"
                    },
                    "doc": "The BED file that contains peak information.",
                    "id": "#snapanalysis_add_pmat_tool.cwl/snapanalysis_add_pmat_tool/peak_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--snap-file"
                    },
                    "doc": "The SNAP file to be processed.",
                    "id": "#snapanalysis_add_pmat_tool.cwl/snapanalysis_add_pmat_tool/snap_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--tmp-folder"
                    },
                    "default": "/tmp",
                    "doc": "Directory to store temporary files.",
                    "id": "#snapanalysis_add_pmat_tool.cwl/snapanalysis_add_pmat_tool/tmp_folder"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--verbose"
                    },
                    "default": "TRUE",
                    "doc": "A boolean tag; if true output the progress.",
                    "id": "#snapanalysis_add_pmat_tool.cwl/snapanalysis_add_pmat_tool/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.snap_file.basename)"
                    },
                    "id": "#snapanalysis_add_pmat_tool.cwl/snapanalysis_add_pmat_tool/snap_file_w_peaks"
                }
            ],
            "baseCommand": [
                "snaptools",
                "snap-add-pmat"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snapanalysis_analyze.cwl",
            "label": "snap analysis analyze",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "networkAccess": true,
                    "class": "NetworkAccess"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--encode_blacklist"
                    },
                    "doc": "A BED file of ENCODE blacklist to prevent potential artifacts.",
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/encode_blacklist"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--gene_annotation"
                    },
                    "doc": "A GTF file of gene annotations.",
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/gene_annotation"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--gene_track"
                    },
                    "doc": "A BED file of gene tracks.",
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/gene_track"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--input_snap"
                    },
                    "doc": "The selected barcodes object file.",
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/input_snap"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--processes"
                    },
                    "default": 1,
                    "doc": "Number of processes to use",
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/processes"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--promoters"
                    },
                    "doc": "A BED file of promoters.",
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/promoters"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--selected_barcodes"
                    },
                    "doc": "The selected barcodes object file.",
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/selected_barcodes"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.bed"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/BED_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.csv"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/CSV_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.hdf5"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/HDF5_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.mtx"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/MTX_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.pdf"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/PDF_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.rds"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/RDS_objects"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.txt"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/TXT_files"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "peaks.combined.bed"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/peaks_combined_bed"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "peaks_snap.rds"
                    },
                    "id": "#snapanalysis_analyze.cwl/snapanalysis_analyze/snap_rds"
                }
            ],
            "baseCommand": [
                "Rscript",
                "/opt/snapAnalysis.R"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snapanalysis_motif.cwl",
            "label": "snap analysis motif",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "networkAccess": true,
                    "class": "NetworkAccess"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--snap_file"
                    },
                    "doc": "The snap file.",
                    "id": "#snapanalysis_motif.cwl/snapanalysis_motif/snap_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--snap_rds"
                    },
                    "doc": "The snap object RDS file.",
                    "id": "#snapanalysis_motif.cwl/snapanalysis_motif/snap_rds"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.csv"
                    },
                    "id": "#snapanalysis_motif.cwl/snapanalysis_motif/CSV_files"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "chromvar_data.RData"
                    },
                    "id": "#snapanalysis_motif.cwl/snapanalysis_motif/RData_file"
                }
            ],
            "baseCommand": [
                "Rscript",
                "/opt/snapMotifAnalysis.R"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snapanalysis_select_barcode.cwl",
            "label": "snapanalysis select barcode",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "networkAccess": true,
                    "class": "NetworkAccess"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--preferred_barcodes"
                    },
                    "doc": "A CSV file.",
                    "id": "#snapanalysis_select_barcode.cwl/snapanalysis_select_barcode/preferred_barcodes"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.pdf"
                    },
                    "id": "#snapanalysis_select_barcode.cwl/snapanalysis_select_barcode/barcode_PDF_files"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.rds"
                    },
                    "id": "#snapanalysis_select_barcode.cwl/snapanalysis_select_barcode/selected_barcodes"
                }
            ],
            "baseCommand": [
                "Rscript",
                "/opt/snapAnalysis_select_barcode.R"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#alignment_qc.cwl",
            "label": "alignment qc",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    },
                    "id": "#alignment_qc.cwl/alignment_qc_tool/bam_file"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1
                    },
                    "default": 1,
                    "id": "#alignment_qc.cwl/alignment_qc_tool/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "alignment_qc.json"
                    },
                    "id": "#alignment_qc.cwl/alignment_qc_tool/alignment_qc_report"
                }
            ],
            "baseCommand": "/opt/alignment_qc.py"
        },
        {
            "class": "CommandLineTool",
            "id": "#snaptools_add_barcodes_to_reads_tool.cwl",
            "label": "snaptools add barcodes to reads",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--input-barcode-fastq"
                    },
                    "doc": "The fastq file containing the cell barcodes.",
                    "id": "#snaptools_add_barcodes_to_reads_tool.cwl/snaptools_add_barcodes_to_reads_tool/input_barcode_fastq"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--input-fastq1"
                    },
                    "doc": "The first paired end fastq file.",
                    "id": "#snaptools_add_barcodes_to_reads_tool.cwl/snaptools_add_barcodes_to_reads_tool/input_fastq1"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--input-fastq2"
                    },
                    "doc": "The second paired end fastq file.",
                    "id": "#snaptools_add_barcodes_to_reads_tool.cwl/snaptools_add_barcodes_to_reads_tool/input_fastq2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--output-fastq-prefix"
                    },
                    "default": "barcode_added",
                    "doc": "The prefix to use for the output fastq files with barcodes added to the read sequence identifier.",
                    "id": "#snaptools_add_barcodes_to_reads_tool.cwl/snaptools_add_barcodes_to_reads_tool/output_fastq_prefix"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_fastq_prefix).R1.fastq"
                    },
                    "id": "#snaptools_add_barcodes_to_reads_tool.cwl/snaptools_add_barcodes_to_reads_tool/barcode_added_fastq1"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_fastq_prefix).R3.fastq"
                    },
                    "id": "#snaptools_add_barcodes_to_reads_tool.cwl/snaptools_add_barcodes_to_reads_tool/barcode_added_fastq2"
                }
            ],
            "baseCommand": [
                "/opt/add_barcodes_to_reads.pl"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-01-09",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Pearl",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snaptools_align_paired_end_tool.cwl",
            "label": "snaptools align paired end reads",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "arguments": [
                {
                    "position": 1,
                    "valueFrom": "--"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--aligner"
                    },
                    "default": "bwa",
                    "doc": "The name of the aligner, e.g. 'bwa'.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/aligner"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "--aligner-options",
                        "position": 8
                    },
                    "doc": "List of strings indicating options you would like passed to aligner.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/aligner_options"
                },
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--alignment-index"
                    },
                    "doc": "The alignment index to use.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/alignment_index"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 12,
                        "prefix": "--if-sort"
                    },
                    "doc": "Whether to sort the bam file based on the read name.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/if_sort"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--input-fastq1"
                    },
                    "doc": "The first paired end fastq file to be aligned.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/input_fastq1"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--input-fastq2"
                    },
                    "doc": "The second paired end fastq file to be aligned.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/input_fastq2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "--min-cov"
                    },
                    "doc": "Minimum number of fragments per barcode.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/min_cov"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "--num-threads"
                    },
                    "default": 8,
                    "doc": "The number of threads to use.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/num_threads"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--output-bam"
                    },
                    "default": "snaptools_alignment.bam",
                    "doc": "The name to use for the output bam file containing unfiltered alignments.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/output_bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 14,
                        "prefix": "--overwrite"
                    },
                    "doc": "Whether to overwrite the output file if it already exists.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/overwrite"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--path-to-aligner"
                    },
                    "default": "/usr/local/bin",
                    "doc": "The file system path to the aligner.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/path_to_aligner"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 9,
                        "prefix": "--read-fastq-command"
                    },
                    "doc": "Command line to execute for each of the input files.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/read_fastq_command"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 13,
                        "prefix": "--tmp-folder"
                    },
                    "default": "/tmp",
                    "doc": "Directory to store temporary files.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/tmp_folder"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 15,
                        "prefix": "--verbose"
                    },
                    "doc": "A boolean tag; if true output the progress.",
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_bam)"
                    },
                    "id": "#snaptools_align_paired_end_tool.cwl/snaptools_align_paired_end/paired_end_bam"
                }
            ],
            "baseCommand": [
                "/opt/snaptools_wrapper.py",
                "align-paired-end"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snaptools_create_cell_by_bin_matrix_tool.cwl",
            "label": "snaptools create cell by bin matrix",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        {
                            "entry": "$(inputs.snap_file)",
                            "writable": true
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "--bin-size-list",
                        "position": 2
                    },
                    "default": [
                        50,
                        1000,
                        5000,
                        10000
                    ],
                    "doc": "A list of bin size(s) to create in the cell-by-bin count matrix.",
                    "id": "#snaptools_create_cell_by_bin_matrix_tool.cwl/snaptools_create_cell_by_bin_matrix/bin_size_list"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--snap-file"
                    },
                    "doc": "The SNAP file in which to place the cell by bin matrix.",
                    "id": "#snaptools_create_cell_by_bin_matrix_tool.cwl/snaptools_create_cell_by_bin_matrix/snap_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "--tmp-folder"
                    },
                    "default": "/tmp",
                    "doc": "Directory to store temporary files.",
                    "id": "#snaptools_create_cell_by_bin_matrix_tool.cwl/snaptools_create_cell_by_bin_matrix/tmp_folder"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 13,
                        "prefix": "--verbose"
                    },
                    "default": "TRUE",
                    "doc": "A boolean tag; if true output the progress.",
                    "id": "#snaptools_create_cell_by_bin_matrix_tool.cwl/snaptools_create_cell_by_bin_matrix/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.snap_file.basename)"
                    },
                    "id": "#snaptools_create_cell_by_bin_matrix_tool.cwl/snaptools_create_cell_by_bin_matrix/snap_file_w_cell_by_bin"
                }
            ],
            "baseCommand": [
                "snaptools",
                "snap-add-bmat"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "label": "snaptools create fragment file",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "/opt/bulk/sort_index_frag.py",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "The bam file to use",
                    "id": "#snaptools_create_fragment_file.cwl/input_bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.sort.bed.gz"
                    },
                    "id": "#snaptools_create_fragment_file.cwl/fragment_file"
                }
            ],
            "id": "#snaptools_create_fragment_file.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#snaptools_fastqc_tool.cwl",
            "label": "snaptools fastqc tool",
            "requirements": [
                {
                    "dockerPull": "biocontainers/fastqc:v0.11.8dfsg-2-deb_cv1",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        "$(inputs.sequence_files)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--extract"
                    },
                    "doc": "Do not uncompress the output file after creating it.",
                    "id": "#snaptools_fastqc_tool.cwl/snaptools_fastqc_tool/extract"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outdir"
                    },
                    "doc": "Create all output files in the specified output directory.",
                    "id": "#snaptools_fastqc_tool.cwl/snaptools_fastqc_tool/outdir"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "set of sequence files for each of which a quality control report is produced",
                    "id": "#snaptools_fastqc_tool.cwl/snaptools_fastqc_tool/sequence_files"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.html"
                    },
                    "doc": "HTML reports with embedded graphs",
                    "id": "#snaptools_fastqc_tool.cwl/snaptools_fastqc_tool/report_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.zip"
                    },
                    "doc": "Individual graph files and additional data files containing the raw data from which plots were drawn.",
                    "id": "#snaptools_fastqc_tool.cwl/snaptools_fastqc_tool/zipped_files"
                }
            ],
            "baseCommand": [
                "fastqc"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2020-03-19",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snaptools_index_ref_genome_tool.cwl",
            "label": "snaptools index reference genome",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        "$(inputs.input_fasta)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--alignment-index"
                    },
                    "doc": "The alignment index file in tar.* format. If provided snaptools index-genome is not called.",
                    "id": "#snaptools_index_ref_genome_tool.cwl/snaptools_index_ref_genome/alignment_index"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--reference-genome"
                    },
                    "doc": "The reference genome file in FASTA format, if in",
                    "id": "#snaptools_index_ref_genome_tool.cwl/snaptools_index_ref_genome/input_fasta"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--size-index"
                    },
                    "doc": "The genome size index, produced by \"samtools faidx\".",
                    "id": "#snaptools_index_ref_genome_tool.cwl/snaptools_index_ref_genome/size_index"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "outputBinding": {
                        "glob": "index"
                    },
                    "id": "#snaptools_index_ref_genome_tool.cwl/snaptools_index_ref_genome/genome_alignment_index"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.fai"
                    },
                    "id": "#snaptools_index_ref_genome_tool.cwl/snaptools_index_ref_genome/genome_size_index"
                }
            ],
            "baseCommand": [
                "/opt/index_reference_genome.py"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snaptools_preprocess_reads_tool.cwl",
            "label": "snaptools preprocess reads",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "arguments": [
                {
                    "position": 1,
                    "valueFrom": "--"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--barcode-file",
                        "position": 6
                    },
                    "doc": "A text file containing pre-selected cell barcodes.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/barcode_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--genome-name"
                    },
                    "default": "hg38",
                    "doc": "The genome identifier (i.e. hg19, hg38, mm10).",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/genome_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--genome-size"
                    },
                    "doc": "A a text file that contains corresponding genome sizes.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/genome_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--input-file"
                    },
                    "doc": "The BAM file to be processed.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "--keep-chrm"
                    },
                    "default": "TRUE",
                    "doc": "A boolean tag indicating whether to keep fragments mapped to chrM.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/keep_chrm"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 14,
                        "prefix": "--keep-discordant"
                    },
                    "doc": "A boolean tag indicating whether to keep discordant read pairs.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/keep_discordant"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 13,
                        "prefix": "--keep-secondary"
                    },
                    "default": "FALSE",
                    "doc": "A boolean tag indicating whether to keep secondary alignments.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/keep_secondary"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 12,
                        "prefix": "--keep-single"
                    },
                    "default": "TRUE",
                    "doc": "A boolean tag indicating whether to keep those reads whose mates are not mapped or are missing.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/keep_single"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 9,
                        "prefix": "--max-flen"
                    },
                    "default": 1000,
                    "doc": "Maximum fragment length.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/max_flen"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "--min-cov"
                    },
                    "default": 100,
                    "doc": "Minimum number of fragments per barcode.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/min_cov"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 8,
                        "prefix": "--min-flen"
                    },
                    "default": 0,
                    "doc": "Minimum fragment length.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/min_flen"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--min-mapq"
                    },
                    "default": 30,
                    "doc": "Minimum mappability score.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/min_mapq"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--output-snap"
                    },
                    "default": "snaptools.snap",
                    "doc": "The name to use for the output SNAP file.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/output_snap"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 16,
                        "prefix": "--overwrite"
                    },
                    "default": "TRUE",
                    "doc": "Whether to overwrite the matrix session if it already exists.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/overwrite"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 17,
                        "prefix": "--qc-file"
                    },
                    "doc": "A boolean tag indicating whether to create a master qc file.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/qc_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 15,
                        "prefix": "--tmp-folder"
                    },
                    "default": "/tmp",
                    "doc": "Directory to store temporary files.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/tmp_folder"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 18,
                        "prefix": "--verbose"
                    },
                    "default": "TRUE",
                    "doc": "A boolean tag; if true output the progress.",
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_snap)"
                    },
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/snap_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_snap).qc"
                    },
                    "id": "#snaptools_preprocess_reads_tool.cwl/snaptools_preprocess_reads/snap_qc_file"
                }
            ],
            "baseCommand": [
                "/opt/snaptools_wrapper.py",
                "snap-pre"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#snaptools_remove_blacklist.cwl",
            "label": "snaptools remove blacklist",
            "requirements": [
                {
                    "dockerPull": "hubmap/sc-atac-seq-grch38:1.0",
                    "class": "DockerRequirement"
                },
                {
                    "coresMin": 1,
                    "ramMin": 1024,
                    "outdirMin": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--bam-file"
                    },
                    "doc": "The genome BAM file to be processed.",
                    "id": "#snaptools_remove_blacklist.cwl/snaptools_remove_blacklist/bam_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--bed-file"
                    },
                    "doc": "The genome BED file with the blacklisted regions to be removed.",
                    "id": "#snaptools_remove_blacklist.cwl/snaptools_remove_blacklist/bed_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "rmsk.bam"
                    },
                    "id": "#snaptools_remove_blacklist.cwl/snaptools_remove_blacklist/rmsk_bam"
                }
            ],
            "baseCommand": [
                "/opt/remove_blacklist.sh"
            ],
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2020-3-4",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python",
            "http://purl.org/dc/terms/creator": {
                "@id": "https://orcid.org/0000-0001-5173-4627",
                "http://xmlns.com/foaf/0.1/name": "Walter Shands",
                "http://xmlns.com/foaf/0.1/mbox": "jshands@ucsc.edu"
            }
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/encode_blacklist"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/gene_annotation"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/gene_track"
                },
                {
                    "type": "File",
                    "id": "#snapanalysis_setup_and_analyze.cwl/input_snap"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/preferred_barcodes"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/processes"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/promoters"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/BED_files",
                    "id": "#snapanalysis_setup_and_analyze.cwl/analysis_BED_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/CSV_files",
                    "id": "#snapanalysis_setup_and_analyze.cwl/analysis_CSV_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/HDF5_files",
                    "id": "#snapanalysis_setup_and_analyze.cwl/analysis_HDF5_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/MTX_files",
                    "id": "#snapanalysis_setup_and_analyze.cwl/analysis_MTX_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/PDF_files",
                    "id": "#snapanalysis_setup_and_analyze.cwl/analysis_PDF_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/RDS_objects",
                    "id": "#snapanalysis_setup_and_analyze.cwl/analysis_RDS_objects"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/TXT_files",
                    "id": "#snapanalysis_setup_and_analyze.cwl/analysis_TXT_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_motif/CSV_files",
                    "id": "#snapanalysis_setup_and_analyze.cwl/motif_CSV_files"
                },
                {
                    "type": "File",
                    "outputSource": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_motif/RData_file",
                    "id": "#snapanalysis_setup_and_analyze.cwl/motif_RData_file"
                }
            ],
            "steps": [
                {
                    "run": "#snapanalysis_add_pmat_tool.cwl",
                    "in": [
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/peaks_combined_bed",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_add_pmat_tool/peak_file"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/input_snap",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_add_pmat_tool/snap_file"
                        }
                    ],
                    "out": [
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_add_pmat_tool/snap_file_w_peaks"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_add_pmat_tool"
                },
                {
                    "run": "#snapanalysis_analyze.cwl",
                    "in": [
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/encode_blacklist",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/encode_blacklist"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/gene_annotation",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/gene_annotation"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/gene_track",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/gene_track"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/input_snap",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/input_snap"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/processes",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/processes"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/promoters",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/promoters"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_select_barcode/selected_barcodes",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/selected_barcodes"
                        }
                    ],
                    "out": [
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/snap_rds",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/peaks_combined_bed",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/CSV_files",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/HDF5_files",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/BED_files",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/PDF_files",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/RDS_objects",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/TXT_files",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/MTX_files"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze"
                },
                {
                    "run": "#snapanalysis_motif.cwl",
                    "in": [
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_add_pmat_tool/snap_file_w_peaks",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_motif/snap_file"
                        },
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_analyze/snap_rds",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_motif/snap_rds"
                        }
                    ],
                    "out": [
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_motif/CSV_files",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_motif/RData_file"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_motif"
                },
                {
                    "run": "#snapanalysis_select_barcode.cwl",
                    "in": [
                        {
                            "source": "#snapanalysis_setup_and_analyze.cwl/preferred_barcodes",
                            "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_select_barcode/preferred_barcodes"
                        }
                    ],
                    "out": [
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_select_barcode/selected_barcodes",
                        "#snapanalysis_setup_and_analyze.cwl/snapanalysis_select_barcode/barcode_PDF_files"
                    ],
                    "id": "#snapanalysis_setup_and_analyze.cwl/snapanalysis_select_barcode"
                }
            ],
            "id": "#snapanalysis_setup_and_analyze.cwl",
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapATAC/tree/feature/snap-analysis",
            "https://schema.org/dateCreated": "2019-12-03",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/alignment_index"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "id": "#snaptools_create_snap_file.cwl/bin_size_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/blacklist_bed"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/encode_blacklist"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/gene_annotation"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/gene_track"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/genome_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/input_barcode_fastq"
                },
                {
                    "type": "File",
                    "id": "#snaptools_create_snap_file.cwl/input_fastq1"
                },
                {
                    "type": "File",
                    "id": "#snaptools_create_snap_file.cwl/input_fastq2"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/preferred_barcodes"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/processes"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/promoters"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/reference_genome_fasta"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/size_index"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/tmp_folder"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#snaptools_create_snap_file.cwl/alignment_qc/alignment_qc_report",
                    "id": "#snaptools_create_snap_file.cwl/alignment_qc_report"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_BED_files",
                    "id": "#snaptools_create_snap_file.cwl/analysis_BED_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_CSV_files",
                    "id": "#snaptools_create_snap_file.cwl/analysis_CSV_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_HDF5_files",
                    "id": "#snaptools_create_snap_file.cwl/analysis_HDF5_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_MTX_files",
                    "id": "#snaptools_create_snap_file.cwl/analysis_MTX_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_PDF_files",
                    "id": "#snaptools_create_snap_file.cwl/analysis_PDF_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_RDS_objects",
                    "id": "#snaptools_create_snap_file.cwl/analysis_RDS_objects"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_TXT_files",
                    "id": "#snaptools_create_snap_file.cwl/analysis_TXT_files"
                },
                {
                    "type": "File",
                    "outputSource": "#snaptools_create_snap_file.cwl/snaptools_remove_blacklist/rmsk_bam",
                    "id": "#snaptools_create_snap_file.cwl/bam_file"
                },
                {
                    "type": "File",
                    "outputSource": "#snaptools_create_snap_file.cwl/snaptools_create_fragment_file/fragment_file",
                    "id": "#snaptools_create_snap_file.cwl/fragment_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/motif_CSV_files",
                    "id": "#snaptools_create_snap_file.cwl/motif_CSV_files"
                },
                {
                    "type": "File",
                    "outputSource": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/motif_RData_file",
                    "id": "#snaptools_create_snap_file.cwl/motif_RData_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snaptools_fastqc_tool/report_files",
                    "id": "#snaptools_create_snap_file.cwl/report_files"
                },
                {
                    "type": "File",
                    "outputSource": "#snaptools_create_snap_file.cwl/snaptools_create_cell_by_bin_matrix/snap_file_w_cell_by_bin",
                    "id": "#snaptools_create_snap_file.cwl/snap_file"
                },
                {
                    "type": "File",
                    "outputSource": "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads/snap_qc_file",
                    "id": "#snaptools_create_snap_file.cwl/snap_qc_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#snaptools_create_snap_file.cwl/snaptools_fastqc_tool/zipped_files",
                    "id": "#snaptools_create_snap_file.cwl/zipped_files"
                }
            ],
            "steps": [
                {
                    "run": "#alignment_qc.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/paired_end_bam",
                            "id": "#snaptools_create_snap_file.cwl/alignment_qc/bam_file"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/threads",
                            "id": "#snaptools_create_snap_file.cwl/alignment_qc/threads"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/alignment_qc/alignment_qc_report"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/alignment_qc"
                },
                {
                    "run": "#snapanalysis_setup_and_analyze.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/encode_blacklist",
                            "id": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/encode_blacklist"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/gene_annotation",
                            "id": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/gene_annotation"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/gene_track",
                            "id": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/gene_track"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_create_cell_by_bin_matrix/snap_file_w_cell_by_bin",
                            "id": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/input_snap"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/preferred_barcodes",
                            "id": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/preferred_barcodes"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/promoters",
                            "id": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/promoters"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_CSV_files",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_BED_files",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_PDF_files",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_HDF5_files",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_RDS_objects",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_TXT_files",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/analysis_MTX_files",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/motif_CSV_files",
                        "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze/motif_RData_file"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snapanalysis_setup_and_analyze"
                },
                {
                    "run": "#snaptools_add_barcodes_to_reads_tool.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/input_barcode_fastq",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool/input_barcode_fastq"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/input_fastq1",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool/input_fastq1"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/input_fastq2",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool/input_fastq2"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool/barcode_added_fastq1",
                        "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool/barcode_added_fastq2"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool"
                },
                {
                    "run": "#snaptools_align_paired_end_tool.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome/genome_alignment_index",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/alignment_index"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool/barcode_added_fastq1",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/input_fastq1"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_add_barcodes_to_reads_tool/barcode_added_fastq2",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/input_fastq2"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/threads",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/num_threads"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/tmp_folder",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/tmp_folder"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/paired_end_bam"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end"
                },
                {
                    "run": "#snaptools_create_cell_by_bin_matrix_tool.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/bin_size_list",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_create_cell_by_bin_matrix/bin_size_list"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads/snap_file",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_create_cell_by_bin_matrix/snap_file"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_create_cell_by_bin_matrix/snap_file_w_cell_by_bin"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_create_cell_by_bin_matrix"
                },
                {
                    "run": "#snaptools_create_fragment_file.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/paired_end_bam",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_create_fragment_file/input_bam"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_create_fragment_file/fragment_file"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_create_fragment_file"
                },
                {
                    "run": "#snaptools_fastqc_tool.cwl",
                    "in": [
                        {
                            "source": [
                                "#snaptools_create_snap_file.cwl/input_fastq1",
                                "#snaptools_create_snap_file.cwl/input_fastq2"
                            ],
                            "id": "#snaptools_create_snap_file.cwl/snaptools_fastqc_tool/sequence_files"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_fastqc_tool/zipped_files",
                        "#snaptools_create_snap_file.cwl/snaptools_fastqc_tool/report_files"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_fastqc_tool"
                },
                {
                    "run": "#snaptools_index_ref_genome_tool.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/alignment_index",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome/alignment_index"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/reference_genome_fasta",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome/input_fasta"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/size_index",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome/size_index"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome/genome_alignment_index",
                        "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome/genome_size_index"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome"
                },
                {
                    "run": "#snaptools_preprocess_reads_tool.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/genome_name",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads/genome_name"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_index_ref_genome/genome_size_index",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads/genome_size"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_remove_blacklist/rmsk_bam",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads/input_bam"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads/snap_file",
                        "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads/snap_qc_file"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_preprocess_reads"
                },
                {
                    "run": "#snaptools_remove_blacklist.cwl",
                    "in": [
                        {
                            "source": "#snaptools_create_snap_file.cwl/snaptools_align_paired_end/paired_end_bam",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_remove_blacklist/bam_file"
                        },
                        {
                            "source": "#snaptools_create_snap_file.cwl/blacklist_bed",
                            "id": "#snaptools_create_snap_file.cwl/snaptools_remove_blacklist/bed_file"
                        }
                    ],
                    "out": [
                        "#snaptools_create_snap_file.cwl/snaptools_remove_blacklist/rmsk_bam"
                    ],
                    "id": "#snaptools_create_snap_file.cwl/snaptools_remove_blacklist"
                }
            ],
            "id": "#snaptools_create_snap_file.cwl",
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/identifier": "https://orcid.org/0000-0001-5173-4627",
                    "https://schema.org/email": "jshands@ucsc.edu",
                    "https://schema.org/name": "Walter Shands"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/wshands/SnapTools/tree/feature/docker_cwl",
            "https://schema.org/dateCreated": "2019-11-15",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0",
            "https://schema.org/keywords": "edam:topic_0091 , edam:topic_0622",
            "https://schema.org/programmingLanguage": "Python"
        }
    ],
    "cwlVersion": "v1.1",
    "$schemas": [
        "https://schema.org/docs/schema_org_rdfa.html",
        "http://edamontology.org/EDAM_1.18.owl"
    ],
    "$namespaces": {
        "s": "https://schema.org/",
        "edam": "http://edamontology.org/"
    }
}
